var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name3 in all)
    __defProp(target, name3, { get: all[name3], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// packages/plugins/qa/src/index.ts
var src_exports = {};
__export(src_exports, {
  install: () => install3,
  name: () => name2,
  use: () => use2
});
module.exports = __toCommonJS(src_exports);
var import_plugin_database = require("@zhinjs/plugin-database");

// packages/plugins/qa/src/models/question.ts
var import_sequelize = require("sequelize");
var QA = {
  question: import_sequelize.DataTypes.TEXT,
  answer: import_sequelize.DataTypes.TEXT,
  isReg: import_sequelize.DataTypes.BOOLEAN,
  probability: {
    type: import_sequelize.DataTypes.FLOAT,
    defaultValue: 1
  },
  redirect: import_sequelize.DataTypes.TEXT,
  belongs: {
    type: import_sequelize.DataTypes.TEXT,
    get() {
      const str = this.getDataValue("belongs") || "";
      if (!str)
        return [];
      return str.split(",").filter(Boolean).map((str2) => {
        const [type, ...rest] = str2.split(":").filter(Boolean);
        return { type, target: rest.join(":") };
      });
    },
    set(data) {
      const belongs = data.map((item) => `${item.type}:${item.target}`).join(",");
      this.setDataValue("belongs", belongs);
    }
  },
  who: import_sequelize.DataTypes.STRING,
  where: import_sequelize.DataTypes.STRING,
  useTimes: {
    type: import_sequelize.DataTypes.INTEGER,
    defaultValue: 0
  }
};

// packages/plugins/qa/src/teach.ts
var teach_exports = {};
__export(teach_exports, {
  DialogueCnMap: () => DialogueCnMap,
  install: () => install,
  use: () => use
});
var import_zhin = require("zhin");
var import_sequelize2 = require("sequelize");
var DialogueCnMap = {
  id: "ID",
  answer: "回答",
  isReg: "是否正则",
  question: "问题",
  probability: "权重",
  useTimes: "使用次数",
  who: "作者",
  where: "来源",
  belongs: "触发条件",
  redirect: "重定向到",
  group: "群",
  private: "好友",
  discuss: "讨论组"
};
function transformDialogueValue(key, value) {
  if (key === "belongs") {
    if (!value.length)
      return "所有消息均可触发";
    return value.map((item) => `${transformDialogueKey(item.type)}消息,指定${transformDialogueKey(item.type)}:${item.target}`).join("\n");
  }
  return value;
}
__name(transformDialogueValue, "transformDialogueValue");
function transformDialogueKey(key) {
  return DialogueCnMap[key] || key;
}
__name(transformDialogueKey, "transformDialogueKey");
function transformDialogue(dialogue) {
  return Object.keys(dialogue).map((key) => {
    return `${transformDialogueKey(key)}:${transformDialogueValue(key, dialogue[key])}`;
  }).join("\n");
}
__name(transformDialogue, "transformDialogue");
import_zhin.template.set("teach", {
  "list": `已有问答如下:
{0}
{1}`,
  "detail": `问答({0})的详情:
{1}`,
  "add": `问答({0})已添加`,
  "edit": `问答({0})已更新`,
  "remove": `问答({0})已删除`,
  "pagination": "第{0}/{1}页，共{2}条",
  "search": `关键词({0})的搜索结果:
{1}
{2}`,
  "404": `{0}({1})未找到任何有关问答`
});
var use = ["database"];
function install(ctx) {
  ctx.command("qa [question:string] [answer:text]").desc("问答管理").option("-l [list:boolean] 查看问答列表").option("-i [info:integer] 查看指定教学详情").option("-s [search:string] 搜索关键词").option("-d [delete:integer] 删除指定id的教学").option("-x [regexp:regexp] 是否为正则匹配").option("-> [redirect:string] 重定向到指定问题").option("-p [probability:number] 触发概率").option("-t [trigger:string] 触发环境，默认(master/admins:【*】 owner/admin:【group:group_id】 member:【group:group_id:user_id】friend:【private:user_id】)").option("-P [page:number] 页码").sugar(/^## (\S+)$/, { options: { search: "$1" } }).option("-e [edit:boolean] 是否为编辑").sugar(/^删除问答(\d+)$/, { options: { delete: "$1" } }).sugar(/^查看问答(\d+)$/, { options: { info: "$1" } }).action(async ({ session, options }, q, a) => {
    if (Object.keys(options).filter((key) => ["list", "detail", "search", "edit", "remove"].includes(key)).length > 1) {
      return "查询/列表/详情、编辑/删除只能同时调用一个";
    }
    let trigger = options.trigger || (session.isMaster ? "*" : session.isOwner || session.isAdmin ? `group:${session.group_id}` : [
      session.detail_type,
      session.guild_id,
      session.channel_id,
      session.group_id,
      session.user_id
    ].filter((item) => !!item).join(":"));
    if (!trigger) {
      trigger = [
        session.isMaster ? "*" : session.detail_type,
        session.guild_id || session.group_id || session.discuss_id,
        session.channel_id,
        session.isOwner || session.isAdmin ? "*" : session.user_id
      ].filter(Boolean).join(":");
    } else if (/^\*$/.test(trigger) && !session.isMaster || /group/.test(trigger) && !session.isOwner && !session.isAdmin) {
      trigger = [
        session.detail_type,
        session.guild_id || session.group_id || session.discuss_id,
        session.channel_id,
        session.user_id
      ].filter((item) => !!item).join(":");
    }
    const tmpArr = trigger.split(",").filter(Boolean).map((str) => {
      const [type, group_id, channel_id, user_id] = str.split(":");
      return {
        type,
        guild_id: type === "guild" ? group_id || "*" : void 0,
        channel_id: type === "guild" ? channel_id || "*" : void 0,
        group_id: type === "group" ? group_id || "*" : void 0,
        user_id: type === "private" ? group_id : type === "group" || "*" ? channel_id || "*" : type === "guild" ? user_id || "*" : "*"
      };
    }).filter((tmp) => !!tmp.type);
    function filterResult(list) {
      const result = list.map((teach) => teach.toJSON()).filter((dialogue) => {
        return dialogue.belongs.length === 0 || dialogue.belongs.some((belong) => {
          if (belong.type === "*")
            return true;
          let [guild_id, channel_id, group_id = guild_id, user_id = channel_id] = belong.target.split(":");
          if (belong.type === "private")
            user_id = guild_id;
          return tmpArr.some((tmp) => {
            if (belong.type === "*" || tmp.type === "*")
              return true;
            if (belong.type !== tmp.type)
              return false;
            if (belong.type === "guild")
              return guild_id === "*" || guild_id === tmp.guild_id && (channel_id === "*" || channel_id === tmp.channel_id);
            if (belong.type === "group")
              return group_id === "*" || group_id === tmp.group_id && (user_id === "*" || user_id === tmp.user_id);
            if (belong.type === "private")
              return user_id === "*" || user_id === tmp.user_id;
          });
        });
      }).map((dialogue, idx) => `${idx + 1}. ID:${dialogue.id} 问题:${dialogue.question} 回答:${dialogue.answer} 是否正则:${dialogue.isReg ? "是" : "否"}${dialogue.redirect ? ` 重定向到:${dialogue.redirect}` : ""}`);
      return {
        rows: result.filter((_, index) => index >= ((options.page || 1) - 1) * 15 && index < (options.page || 1) * 15),
        count: result.length
      };
    }
    __name(filterResult, "filterResult");
    if (options.search) {
      const condition = {
        where: {
          [import_sequelize2.Op.or]: {
            question: { [import_sequelize2.Op.like]: `%${options.search}%` },
            answer: { [import_sequelize2.Op.like]: `%${options.search}%` }
          }
        },
        sort: [["createdAt", "DESC"]]
      };
      if (options.page) {
        if (!Number.isInteger(options.page) || options.page < 1)
          return "页码只能为正整数";
      }
      const data = await ctx.database.models.QA.findAll(condition);
      const { rows, count } = filterResult(data);
      return (0, import_zhin.h)("text", { text: (0, import_zhin.template)("teach.search", options.search, rows.join("\n"), (0, import_zhin.template)("teach.pagination", options.page || 1, Math.ceil(count / 15), count)) });
    }
    if (options.list) {
      const condition = {
        where: {},
        sort: [["createdAt", "DESC"]]
      };
      if (options.page) {
        if (!Number.isInteger(options.page) || options.page < 1)
          return "页码只能为正整数";
      }
      const data = await ctx.database.models.QA.findAll(condition);
      const { rows, count } = filterResult(data);
      return (0, import_zhin.h)("text", { text: (0, import_zhin.template)("teach.list", rows.join("\n"), (0, import_zhin.template)("teach.pagination", options.page || 1, Math.ceil(count / 15), count)) });
    }
    if (options.info) {
      const teach = await ctx.database.models.QA.findOne({
        where: {
          id: options.info
        }
      });
      if (!teach) {
        return (0, import_zhin.template)("teach.404", "ID", options.info);
      }
      const dialogue = teach.toJSON();
      return (0, import_zhin.h)("text", { text: (0, import_zhin.template)("teach.detail", options.info, transformDialogue(dialogue)) });
    }
    if (options.delete) {
      const dialogue = await ctx.database.models.QA.destroy({
        where: {
          id: options.delete
        }
      });
      if (dialogue) {
        return (0, import_zhin.template)("teach.remove", options.delete);
      }
    }
    if (q) {
      const data = {
        isReg: !!options.regexp,
        who: String(session.user_id),
        belongs: tmpArr.some((tmp) => tmp.type === "*") ? [] : tmpArr.map((tmp) => {
          return {
            type: tmp.type,
            target: [
              tmp.guild_id,
              tmp.channel_id,
              tmp.group_id,
              tmp.user_id
            ].filter(Boolean).join(":")
          };
        }),
        where: [
          transformDialogueKey(session.detail_type),
          session.group_id || session.discuss_id || session.channel_id
        ].filter((v) => !!v).join(":")
      };
      if (a) {
        data.answer = a;
      }
      if (options.probability) {
        data.probability = options.probability;
      }
      if (options.redirect) {
        data.redirect = options.redirect;
      }
      let dialogues = await ctx.database.models.QA.findAll({
        where: {
          question: q
        }
      });
      let [dialogue] = dialogues;
      if (options.edit) {
        if (dialogues.length > 1) {
          await session.reply((0, import_zhin.template)("teach.list", filterResult(dialogues).rows.join("\n"), "请输入要编辑的问答索引"));
          const index = await session.prompt.select("请选择要编辑的问答", {
            child_type: "number",
            options: filterResult(dialogues).rows.map((item, i) => ({ title: item, value: i }))
          });
          if (typeof index !== "number")
            return "输入超时";
          if (index < 1 || index > dialogues.length) {
            await session.reply("输入错误");
            return;
          }
          dialogue = dialogues[index - 1];
        }
        if (!dialogue) {
          return (0, import_zhin.template)("teach.404", "问题", q);
        }
        await dialogue.update(data);
        return (0, import_zhin.template)("teach.edit", dialogue.get("id"));
      }
      if (dialogue && dialogue.get("answer") === a) {
        const confirm = await session.prompt.confirm("已存在相同问答，是否继续添加？");
        if (!confirm)
          return "已取消添加";
      }
      dialogue = await ctx.database.models.QA.create({
        ...data,
        question: q
      });
      return (0, import_zhin.template)("teach.add", dialogue.get("id"));
    }
  });
}
__name(install, "install");

// packages/plugins/qa/src/receiver.ts
var receiver_exports = {};
__export(receiver_exports, {
  install: () => install2,
  name: () => name,
  triggerTeach: () => triggerTeach
});
function hasEnv(envs, type, target) {
  return envs.length === 0 || envs.some((env) => {
    if (env.type === "*")
      return true;
    if (env.type === "guild") {
      const [guild_id, channel_id = "*", user_id = "*"] = target.split(":").filter(Boolean);
      const [env_guild_id, env_channel_id = "*", env_user_id = "*"] = env.target.split(":");
      return env_guild_id === guild_id && (env_channel_id === "*" || env_channel_id === channel_id) && (env_user_id === "*" || env_user_id === user_id);
    } else if (env.type === "group") {
      const [group_id, user_id = "*"] = target.split(":").filter(Boolean);
      const [env_group_id, env_user_id = "*"] = env.target.split(":");
      return env_group_id === group_id && (env_user_id === "*" || env_user_id === user_id);
    } else if (env.type === "user") {
      return env.target === "*" || env.target === target;
    }
  });
}
__name(hasEnv, "hasEnv");
async function triggerTeach(ctx, session) {
  const teaches = await ctx.database.models.QA.findAll();
  const question = session.content;
  const target = [
    session.guild_id,
    session.channel_id,
    session.group_id,
    session.user_id
  ].filter(Boolean).join(":");
  const dialogues = teaches.map((teach2) => teach2.toJSON()).filter((teach2) => hasEnv(teach2.belongs, session.detail_type, target)).filter((teach2) => {
    return teach2.isReg ? new RegExp(teach2.question).test(question) : question === teach2.question;
  });
  const totalProbability = dialogues.reduce((p, dialogue2) => {
    p += dialogue2.probability;
    return p;
  }, 0);
  function fixProbability(probability) {
    let baseProbability = 0;
    dialogues.forEach((dialogue2) => {
      dialogue2.activeArea = [baseProbability, dialogue2.probability / (totalProbability < 0 ? 1 : totalProbability) + baseProbability];
      baseProbability += dialogue2.probability / (totalProbability < 0 ? 1 : totalProbability);
      dialogue2["active"] = probability > dialogue2.activeArea[0] && probability <= dialogue2.activeArea[1];
    });
  }
  __name(fixProbability, "fixProbability");
  fixProbability(Math.random());
  if (!dialogues.length)
    return;
  const [dialogue] = dialogues.filter((d) => d.active);
  const teach = teaches.find((t) => t.getDataValue("id") === dialogue.id);
  if (!dialogue)
    return;
  await teach.update({ useTimes: dialogue.useTimes + 1 });
  if (dialogue.redirect) {
    if (dialogue.isReg) {
      const args = new RegExp(dialogue.question).exec(question);
      let index = 0;
      while (index < args.length - 1) {
        index++;
        const reg = new RegExp("\\$" + index, "gm");
        dialogue.redirect = dialogue.redirect.replace(reg, args[index]);
      }
    }
    session.content = dialogue.redirect;
    return triggerTeach(ctx, session);
  }
  if (dialogue.isReg) {
    const args = new RegExp(dialogue.question).exec(question);
    let index = 0;
    while (index < args.length - 1) {
      index++;
      const reg = new RegExp("\\$" + index, "gm");
      dialogue.answer = dialogue == null ? void 0 : dialogue.answer.replace(reg, args[index]);
    }
  }
  return dialogue.answer.replace(/\$0/g, question);
}
__name(triggerTeach, "triggerTeach");
var name = "qa.receiver";
function install2(ctx) {
  let preMessageId = "";
  ctx.middleware(async (session, next) => {
    await next();
    if (preMessageId === session.message_id)
      return;
    preMessageId = session.message_id;
    if (session.type === "message") {
      const tpl = await triggerTeach(ctx, session).catch(() => {
      });
      if (!tpl)
        return;
      session.reply(tpl);
    }
    ;
  }, true);
}
__name(install2, "install");

// packages/plugins/qa/src/index.ts
var name2 = "qa";
var use2 = ["database"];
async function install3(ctx) {
  ctx.disposes.push(
    await ctx.beforeReady(async () => {
      ctx.disposes.push(
        await ctx.database.onCreated(() => {
          ctx.database.define("QA", QA);
          ctx.disposes.push(() => {
            ctx.database.delete("QA");
          });
        })
      );
    })
  );
  ctx.plugin(teach_exports);
  ctx.plugin(receiver_exports);
}
__name(install3, "install");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  install,
  name,
  use
});
//# sourceMappingURL=index.js.map
